<?php
/*
Plugin Name: WP-PagesAsPosts
Plugin URI: http://www.delphiarea.com/products/wordpress-plugins/wp-pagesasposts/
Description: Elables you to add tags, categories, and excerpt to pages in the same way you do for posts.
Version: 1.0
Author: Kambiz R. Khojasteh
Author URI: kambiz@delphiarea.com
Tags: post, page, tags, categories, excerpt, slug
*/

add_filter('posts_where', 'wp_pages_as_posts_where');
function wp_pages_as_posts_where($where) {
	if (is_category() || is_tag()) {
		if (preg_match("/ ([0-9a-zA-Z_]*\.?)taxonomy = 'category'/", $where, $m))
			$substitue = " (${1}post_type = 'post' OR (${1}post_type = 'page' AND {$m[1]}term_id <> 1))";
		else
			$substitue = " (${1}post_type = 'post' OR ${1}post_type = 'page')";
		$where = preg_replace("/ ([0-9a-zA-Z_]*\.?)post_type = 'post'/", $substitue, $where);
  }
	return $where;
}

function wp_pages_as_posts_query($query) {
	global $wpdb;
	if (strpos($query, "SELECT COUNT(*) FROM $wpdb->term_relationships, $wpdb->posts WHERE") !== false)
		$query = str_replace(" post_type = 'post'", " (post_type = 'post' OR (post_type = 'page' AND $wpdb->term_relationships.term_taxonomy_id <> 1))", $query);
  return $query;
}

add_action('load-page.php', 'wp_pages_as_posts_page_script');
add_action('load-page-new.php', 'wp_pages_as_posts_page_script');
function wp_pages_as_posts_page_script() {
	add_action('query', 'wp_pages_as_posts_query');
	wp_deregister_script('page');
	wp_enqueue_script('post');
}

add_action('submitpage_box', 'wp_pages_as_posts_page_meta_boxes');
function wp_pages_as_posts_page_meta_boxes() {
	add_meta_box('tagsdiv', __('Tags'), 'page_tags_meta_box', 'page', 'normal', 'core');
	add_meta_box('categorydiv', __('Categories'), 'page_categories_meta_box', 'page', 'normal', 'core');
	add_meta_box('postexcerpt', __('Excerpt'), 'page_excerpt_meta_box', 'page', 'advanced', 'core');
}

function page_tags_meta_box($post) {
?>
<p id="jaxtag"><label class="hidden" for="newtag"><?php _e('Tags'); ?></label><input type="text" name="tags_input" class="tags-input" id="tags-input" size="40" tabindex="3" value="<?php echo get_tags_to_edit( $post->ID ); ?>" /></p>
<div id="tagchecklist"></div>
<?php
}

function page_categories_meta_box($post) {
?>
<div id="category-adder" class="wp-hidden-children">
	<h4><a id="category-add-toggle" href="#category-add" class="hide-if-no-js" tabindex="3"><?php _e( '+ Add New Category' ); ?></a></h4>
	<p id="category-add" class="wp-hidden-child">
		<label class="hidden" for="newcat"><?php _e( 'Add New Category' ); ?></label><input type="text" name="newcat" id="newcat" class="form-required form-input-tip" value="<?php _e( 'New category name' ); ?>" tabindex="3" aria-required="true"/>
		<label class="hidden" for="newcat_parent"><?php _e('Parent category'); ?>:</label><?php wp_dropdown_categories( array( 'hide_empty' => 0, 'name' => 'newcat_parent', 'orderby' => 'name', 'hierarchical' => 1, 'show_option_none' => __('Parent category'), 'tab_index' => 3 ) ); ?>
		<input type="button" id="category-add-sumbit" class="add:categorychecklist:category-add button" value="<?php _e( 'Add' ); ?>" tabindex="3" />
		<?php wp_nonce_field( 'add-category', '_ajax_nonce', false ); ?>
		<span id="category-ajax-response"></span>
	</p>
</div>

<ul id="category-tabs">
	<li class="ui-tabs-selected"><a href="#categories-all" tabindex="3"><?php _e( 'All Categories' ); ?></a></li>
	<li class="wp-no-js-hidden"><a href="#categories-pop" tabindex="3"><?php _e( 'Most Used' ); ?></a></li>
</ul>

<div id="categories-pop" class="ui-tabs-panel" style="display: none;">
	<ul id="categorychecklist-pop" class="categorychecklist form-no-clear" >
		<?php $popular_ids = wp_popular_terms_checklist('category'); ?>
	</ul>
</div>

<div id="categories-all" class="ui-tabs-panel">
	<ul id="categorychecklist" class="list:category categorychecklist form-no-clear">
		<?php wp_category_checklist($post->ID, false, false, $popular_ids) ?>
	</ul>
</div>
<?php
}

function page_excerpt_meta_box($post) {
?>
<label class="hidden" for="excerpt"><?php _e('Excerpt') ?></label><textarea rows="1" cols="40" name="excerpt" tabindex="6" id="excerpt"><?php echo $post->post_excerpt ?></textarea>
<p><?php _e('Excerpts are optional hand-crafted summaries of your content. You can <a href="http://codex.wordpress.org/Template_Tags/the_excerpt" target="_blank">use them in your template</a>'); ?></p>
<?php
}

?>